"""Declares :class:`MessagePublished`."""
import pydantic

from .pubsubmessage import PubsubMessage

SUBSCRIPTION_NAME = pydantic.constr(
    regex='^projects/[\-a-z0-9]{6,30}/subscriptions/.*$'
)

class MessagePublished(pydantic.BaseModel):
    subscription: SUBSCRIPTION_NAME = pydantic.Field(
        example="projects/myproject/subscriptions/mysub"
    )

    message: PubsubMessage
