"""Declares :class:`ServiceEndpoint`."""
import typing

import cbra
from .googlejwtprincipal import GoogleJWTPrincipal


class ServiceEndpoint(cbra.Resource):
    """A :class:`cbra.Resource` implementation that exposes endpoints for
    Google services, autheticating with Google Cloud IAM.
    """
    __abstract__: bool = True
    principal: GoogleJWTPrincipal = GoogleJWTPrincipal()

    #: The list of Google Cloud IAM service accounts that are allowed to
    #: push messages to the endpoint.
    members: typing.List[str] = []

    # Additional audiences that the endpoint accepts.
    audience: typing.List[str] = []
