# pylint: skip-file
import pytest

import cbra
from cbra.lib.auth import NullJWTPrincipal
from cbra.ext.google import AortaEventarcReceiver
from httpx import AsyncClient


@pytest.fixture(scope='session')
def aorta_receiver(_aorta_register):
    return AortaEventarcReceiver(
        members=["foo@bar.baz"],
        principal_class=lambda *a, **k: NullJWTPrincipal(
            aud="http://aorta.test",
            sub="foo",
            email="foo@bar.baz"
        )
    )


@pytest.fixture(scope='session')
def app(aorta_receiver):
    app = cbra.Application()
    app.add(aorta_receiver, path='/aorta')
    return app


@pytest.fixture(scope='session')
async def client(app):
    kwargs = {
        'base_url': "http://aorta.test",
    }
    async with AsyncClient(app=app, **kwargs) as client:
        yield client
