# pylint: skip-file
import json
from unittest.mock import AsyncMock

import pytest


class TestAortaCommand:

    @pytest.fixture
    def receivable(self, command):
        return command

    @pytest.fixture
    def message(self, command_message):
        return command_message

    @pytest.mark.asyncio
    async def test_receive_valid_message(self, client, message):
        response = await client.post(
            '/aorta',
            data=message
        )
        assert response.status_code == 202

    @pytest.mark.asyncio
    async def test_receive_malformed_message(self, client, message):
        dto = json.loads(message)
        dto['message']['data'] = '['
        response = await client.post(
            '/aorta',
            data=json.dumps(dto),
            headers={
                'Content-Type': "application/json"
            }
        )
        assert response.status_code == 202
