"""Declares :class:`IPrincipal`."""
import typing

import cbra.lib.auth


class IPrincipal(cbra.lib.auth.IPrincipal):
    """A :class:`~cbra.lib.auth.IPrincipal` interface with additional
    methods.
    """
    __module__: str = 'cbra.ext.oauth2'

    #: The OAuth 2.0 client that identified this principal.
    client_id: str

    #: The scope that was granted to the principal.
    scope: typing.Set[str]