"""Declares :class:`ISubjectRepository`."""
import typing

from .exceptions import SubjectDoesNotExist
from .isubject import ISubject


class ISubjectRepository:
    __module__: str = 'cbra.ext.oauth2'
    SubjectDoesNotExist: typing.Type[BaseException] = SubjectDoesNotExist

    async def get(
        self,
        subject_id: typing.Union[int, str],
        client_id: typing.Optional[str] = None
    ) -> ISubject:
        """Return a :class:`ISubject` implementation for the client specified
        by `client_id` and `subject_id`. If `client_id` is ``None``, no properties
        specific to a client/subject relationship are loaded onto the resulting
        :class:`ISubject` instance.
        """
        raise NotImplementedError