# pylint: skip-file
import ckms
import fastapi


__all__ = [
    'CurrentHost',
    'CurrentServer',
    'ServerKeychain',
]


def get_current_host(request: fastapi.Request) -> str:
    return request.url.netloc


def get_current_server(request: fastapi.Request) -> str:
    return f'{request.url.scheme}://{request.url.netloc}'


def get_server_keychain(request: fastapi.Request) -> ckms.Keychain:
    return request.app.keychain


CurrentHost: str = fastapi.Depends(get_current_host)

CurrentServer: str = fastapi.Depends(get_current_server)

ServerKeychain: ckms.Keychain = fastapi.Depends(get_server_keychain)