# pylint: skip-file
import random

import pytest

from .conftest import TestQuery


#@pytest.mark.asyncio
#async def test_run_query():
#    assert await TestQuery.run(foo=1) == 1


def test_query_new(query):
    assert query.foo == 1


@pytest.mark.asyncio
async def test_resolve_query(runner):
    q = TestQuery()
    n = random.randint(0, 1000)
    assert await q.resolve(runner(), foo=n) == n


@pytest.mark.asyncio
async def test_resolve_request_query(client):
    response = await client.get('/', params={'foo': 1})
    dto = response.json()

    assert response.status_code == 200
