# pylint: skip-file
import pytest

import cbra


@pytest.mark.asyncio
async def test_query_get_limit_parameter(app, client):
    assert app.container.is_satisfied('cbra.runner.default')

    @app.get('/{object_id}')
    async def f(query=TestRequestQuery(run=False)):
        return query

    response = await client.get('/1')
    assert response.status_code == 200, response.text
    dto = response.json()
    assert 'limit' in dto
    assert 'offset' in dto
    assert 'args' in dto
    assert dto['args']['object_id'] == 1


class TestRequestQuery(cbra.query.RequestQuery):
    object_id: int
