# pylint: skip-file
import pytest

from unimatrix.exceptions import ProgrammingError

import cbra
from cbra.ext import ioc


@pytest.mark.asyncio
async def test_injected_is_satisfied(app, run_dependant):
    app.inject('foo', 1)
    assert ioc.is_satisfied('foo')


@pytest.mark.asyncio
async def test_inject_simple_value(app, run_dependant):
    app.inject('foo', 1)

    async def f(value=ioc.Injected('foo')):
        return value

    assert await run_dependant(f) == 1


@pytest.mark.asyncio
async def test_inject_generator(run_dependant):
    async def f():
        yield 1

    async def f(value=ioc.Dependency(f)):
        return value

    with pytest.raises(ValueError):
        assert await run_dependant(f) == 1
