# pylint: skip-file
import fastapi

from ..dependantsignature import DependantSignature


def test_get_request_dependencies_returns_cookie():
    def f(value=fastapi.Cookie(...)):
        pass

    sig = DependantSignature(f)
    assert len(sig.get_request_dependencies()) == 1


def test_get_request_dependencies_returns_header():
    def f(value=fastapi.Header(...)):
        pass

    sig = DependantSignature(f)
    assert len(sig.get_request_dependencies()) == 1


def test_get_request_dependencies_returns_path():
    def f(value=fastapi.Path(...)):
        pass

    sig = DependantSignature(f)
    assert len(sig.get_request_dependencies()) == 1


def test_get_request_dependencies_returns_query():
    def f(value=fastapi.Query(...)):
        pass

    sig = DependantSignature(f)
    assert len(sig.get_request_dependencies()) == 1
