# pylint: skip-file
import pytest

import cbra


@pytest.mark.asyncio
async def test_run_dependency_receiver(run_dependant):
    receiver = TestDependencyReceiver()
    result = await run_dependant(receiver)
    assert receiver.host is not None
    assert receiver.host == 'foo.bar.baz'
    assert receiver.called


class TestDependencyReceiver(cbra.DependencyReceiver):
    host = None
    called = False

    async def inject(self, host: str = cbra.Header(..., alias='Host')):
        self.host = host

    async def __call__(self):
        assert self.host is not None
        self.called = True
