# pylint: skip-file
import inspect

import fastapi.params

import cbra
from .conftest import TestCommand
from .conftest import TestEvent


def test_command_is_annotated(command):
    sig = inspect.signature(TestCommandHandler(command.as_envelope()))
    assert isinstance(sig.parameters['command'].default, fastapi.params.Body)


def test_event_is_annotated(event):
    sig = inspect.signature(TestEventListener(event.as_envelope()))
    assert isinstance(sig.parameters['event'].default, fastapi.params.Body)


class TestCommandHandler(cbra.CommandHandler):

    async def handle(self, command: TestCommand):
        pass


class TestEventListener(cbra.EventListener):

    async def handle(self, event: TestEvent):
        pass
