# pylint: skip-file
import pytest


class TestResourceClassConfiguration:

    @pytest.mark.asyncio
    async def test_retrieve_is_exposed(self, client):
        response = await client.get('/examples/1/subs/2')
        assert response.status_code == 200

    @pytest.mark.asyncio
    async def test_retrieve_receives_path_parameter(self, client):
        response = await client.get('/examples/1/subs/2')
        assert response.status_code == 200
        dto = response.json()
        assert dto.get('object_id') == '1'
        assert dto.get('child_id') == 2

    @pytest.mark.asyncio
    async def test_list_is_exposed(self, client):
        response = await client.get('/examples/1/subs')
        assert response.status_code == 200

    @pytest.mark.asyncio
    async def test_list_receives_path_parameter(self, client):
        response = await client.get('/examples/1/subs')
        assert response.status_code == 200
        dto = response.json()
        assert dto.get('object_id') == '1'
