"""Declares :class:`IParser`."""
import typing

import fastapi


class IParser:
    __module__: str = 'cbra.types'
    encoding: typing.Optional[str]
    media_type: str

    def __init__(self, encoding: typing.Optional[str] = None):
        self.encoding = encoding

    async def parse(self,
        request: fastapi.Request,
        media_type: typing.Optional[str] = None,
        parser_context: typing.Optional[typing.Dict[str, typing.Any]] = None
    ) -> typing.Any:
        raise NotImplementedError