import ckms

import cbra
from cbra.ext.jwks import JWKSEndpoint


__all__ = ['get_asgi_application']


def get_asgi_application() -> cbra.Application:
    keychain = ckms.Keychain()
    keychain.register({ # type: ignore
        'sig': {
            'provider': 'local',
            'kty': 'RSA',
            'use': 'sig',
            'tags': ['server'],
            'bit_length': 2048
        },
        'enc': {
            'provider': 'local',
            'kty': 'RSA',
            'use': 'enc',
            'tags': ['server'],
            'bit_length': 2048
        }
    })
    app = cbra.Application(
        keychain=keychain
    )
    app.add(JWKSEndpoint)
    return app


app = get_asgi_application()
if __name__ == '__main__':
    cbra.run('__main__:app', reload=True)
