# pylint: skip-file
import httpx
import pytest
import pytest_asyncio

from examples.jwks import get_asgi_application


@pytest_asyncio.fixture(scope='session')
async def app():
    app = get_asgi_application()
    await app._boot()
    return app


@pytest.mark.asyncio
async def test_jwks_contains_two_keys(client: httpx.AsyncClient):
    response = await client.get('/.well-known/jwks.json')
    dto = response.json()
    assert response.status_code == 200
    assert len(dto['keys']) == 2